package app.main;

import java.util.Random;

import android.graphics.Point;

public class BlockControl implements IBlockControl {

	public BlockControl(IBoard board) {
		super();
		
		_Board = board;
	}
	
	protected IBoard _Board;

	private Random _Random = new Random();
	
	@Override
	public void shuffle() {
		Point point = new Point();
				
		for (int i=0; i<1000; i++) {
			point.set(
					_Random.nextInt(_Board.getBlocks().getWidth()),
					_Random.nextInt(_Board.getBlocks().getHeight())
			);
			
			if (_Board.getBlocks().getBlock(point).isBlankBlock() == false) 
				slide(point);
		}
	}

	@Override
	public void slide(Point point) {
		switch (_Board.getBlocks().getBlankDirection(point)) {
		case Left: moveBlockLeft(point); break;
		case Right: moveBlockRight(point); break;
		case Up: moveBlockUp(point); break;
		case Down: moveBlockDown(point); break;
		}
	}
	
	private void moveBlockLeft(Point point) {
		Point blankPosition = _Board.getBlocks().getBlankPosition();
		
		int blankX = blankPosition.x;
		int blankY = blankPosition.y;
		int count = point.x - blankX;
		
		for (int i=1; i<=count; i++) {
			_Board.getBlocks().moveBlockLeft(blankX+i, blankY);
		}
	}
	
	private void moveBlockRight(Point point) {
		Point blankPosition = _Board.getBlocks().getBlankPosition();
		
		int blankX = blankPosition.x;
		int blankY = blankPosition.y;
		int count = blankX - point.x;
		
		for (int i=1; i<=count; i++) {
			_Board.getBlocks().moveBlockRight(blankX-i, blankY);
		}
	}
	
	private void moveBlockUp(Point point) {
		Point blankPosition = _Board.getBlocks().getBlankPosition();
		
		int blankX = blankPosition.x;
		int blankY = blankPosition.y;
		int count = point.y - blankY;
		
		for (int i=1; i<=count; i++) {
			_Board.getBlocks().moveBlockUp(blankX, blankY+i);
		}
	}
	
	private void moveBlockDown(Point point) {
		Point blankPosition = _Board.getBlocks().getBlankPosition();
		
		int blankX = blankPosition.x;
		int blankY = blankPosition.y;
		int count = blankY - point.y;
		
		for (int i=1; i<=count; i++) {
			_Board.getBlocks().moveBlockDown(blankX, blankY-i);
		}
	}
	
}
