package app.main;

import android.graphics.Canvas;
import android.graphics.Paint;
import ryulib.game.GameControlGroup;
import ryulib.game.GamePlatformInfo;

public class Board extends GameControlGroup implements IBoard {

	public Board(GameControlGroup gameControlGroup) {
		super(gameControlGroup);
		
		gameControlGroup.addControl(this);
	}
	
	private BlockControl _BlockControl = new BlockControl(this);
	private Blocks _Blocks = new Blocks(this);
	
	private int _BlockSize = 0;
	
	public void align() {
		_Blocks.align();
	}
	
	public void shuffle() {
		_BlockControl.shuffle();
	}
	
	@Override
	protected void onDraw(GamePlatformInfo platformInfo) {
		Paint paint = platformInfo.getPaint();
		Canvas canvas = platformInfo.getCanvas();
		
		paint.setARGB(255, 0, 255, 0);
		canvas.drawRect(getBoundary().getRect(), paint);
	}
	
	@Override
	public IBlockControl getBlockControl() {
		return _BlockControl;
	}

	@Override
	public IBlocks getBlocks() {
		return _Blocks;
	}

	@Override
	public int getBlockSize() {
		return _BlockSize;
	}

	public void setBlockSize(int value) {
		_BlockSize =  value;
	}

	public void setBoardSize(int width, int height) {
		_Blocks.setSize(width, height);
	}

}
