package app.main;

import ryulib.OnNotifyEventListener;
import ryulib.game.GamePlatform;
import android.app.Activity;
import android.os.Bundle;
import android.view.ViewGroup;
import android.widget.LinearLayout;

public class Main extends Activity {
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        _GamePlatform = new GamePlatform(this);
        _GamePlatform.setUseMotionEvent(true);
        _GamePlatform.setLayoutParams(
        		new LinearLayout.LayoutParams(
        				ViewGroup.LayoutParams.FILL_PARENT,
        				ViewGroup.LayoutParams.FILL_PARENT,
        				0.0F
        		)
        );
        setContentView(_GamePlatform);
        
        _Board = new Board(_GamePlatform.getGameControlGroup());
        _Board.getBoundary().setBoundary(0, 0, 320, 480);
        _Board.setBlockSize(64);
        _Board.setBoardSize(4, 4);
        
        _ButtonShuffle = new ryulib.game.ImageButton(_GamePlatform.getGameControlGroup());
        _ButtonShuffle.setPosition(10, 350);
        _ButtonShuffle.setImageUp(R.drawable.up);
        _ButtonShuffle.setImageDown(R.drawable.down);
        _ButtonShuffle.setOnClick(_OnShuffle);
    }
    
	private GamePlatform _GamePlatform = null;
    private Board _Board = null;
    private ryulib.game.ImageButton _ButtonShuffle = null;
    
    private OnNotifyEventListener _OnShuffle = new OnNotifyEventListener() {
		@Override
		public void onNotify(Object sender) {
			_Board.shuffle();
		}
	}; 
	
}